<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml" lang="" xml:lang="">
<head>
  <meta charset="utf-8" />
  <meta name="generator" content="pandoc" />
  <meta name="viewport" content="width=device-width, initial-scale=1.0, user-scalable=yes" />
  <title>frontend-checklist</title>
  <style type="text/css">
      code{white-space: pre-wrap;}
      span.smallcaps{font-variant: small-caps;}
      span.underline{text-decoration: underline;}
      div.column{display: inline-block; vertical-align: top; width: 50%;}
  </style>
  <style type="text/css">
a.sourceLine { display: inline-block; line-height: 1.25; }
a.sourceLine { pointer-events: none; color: inherit; text-decoration: inherit; }
a.sourceLine:empty { height: 1.2em; }
.sourceCode { overflow: visible; }
code.sourceCode { white-space: pre; position: relative; }
div.sourceCode { margin: 1em 0; }
pre.sourceCode { margin: 0; }
@media screen {
div.sourceCode { overflow: auto; }
}
@media print {
code.sourceCode { white-space: pre-wrap; }
a.sourceLine { text-indent: -1em; padding-left: 1em; }
}
pre.numberSource a.sourceLine
  { position: relative; left: -4em; }
pre.numberSource a.sourceLine::before
  { content: attr(title);
    position: relative; left: -1em; text-align: right; vertical-align: baseline;
    border: none; pointer-events: all; display: inline-block;
    -webkit-touch-callout: none; -webkit-user-select: none;
    -khtml-user-select: none; -moz-user-select: none;
    -ms-user-select: none; user-select: none;
    padding: 0 4px; width: 4em;
    color: #aaaaaa;
  }
pre.numberSource { margin-left: 3em; border-left: 1px solid #aaaaaa;  padding-left: 4px; }
div.sourceCode
  {  }
@media screen {
a.sourceLine::before { text-decoration: underline; }
}
code span.al { color: #ff0000; font-weight: bold; } /* Alert */
code span.an { color: #60a0b0; font-weight: bold; font-style: italic; } /* Annotation */
code span.at { color: #7d9029; } /* Attribute */
code span.bn { color: #40a070; } /* BaseN */
code span.bu { } /* BuiltIn */
code span.cf { color: #007020; font-weight: bold; } /* ControlFlow */
code span.ch { color: #4070a0; } /* Char */
code span.cn { color: #880000; } /* Constant */
code span.co { color: #60a0b0; font-style: italic; } /* Comment */
code span.cv { color: #60a0b0; font-weight: bold; font-style: italic; } /* CommentVar */
code span.do { color: #ba2121; font-style: italic; } /* Documentation */
code span.dt { color: #902000; } /* DataType */
code span.dv { color: #40a070; } /* DecVal */
code span.er { color: #ff0000; font-weight: bold; } /* Error */
code span.ex { } /* Extension */
code span.fl { color: #40a070; } /* Float */
code span.fu { color: #06287e; } /* Function */
code span.im { } /* Import */
code span.in { color: #60a0b0; font-weight: bold; font-style: italic; } /* Information */
code span.kw { color: #007020; font-weight: bold; } /* Keyword */
code span.op { color: #666666; } /* Operator */
code span.ot { color: #007020; } /* Other */
code span.pp { color: #bc7a00; } /* Preprocessor */
code span.sc { color: #4070a0; } /* SpecialChar */
code span.ss { color: #bb6688; } /* SpecialString */
code span.st { color: #4070a0; } /* String */
code span.va { color: #19177c; } /* Variable */
code span.vs { color: #4070a0; } /* VerbatimString */
code span.wa { color: #60a0b0; font-weight: bold; font-style: italic; } /* Warning */
  </style>
</head>
<body>
<p><a href="https://frontendchecklist.io"><img src="https://github.com/thedaviddias/Front-End-Checklist/blob/master/src/img/banners/front-end-checklist-banner-light.jpg?raw=true" alt="Front-End Checklist Logo" /></a></p>
<h2 align="center">
<a href="https://frontendchecklist.io">Front-End Checklist</a>
</h2>
<p align="center">
<em>The Front-End Checklist is an exhaustive list of all elements you need to have / to test before launching your site / HTML page to production.</em>
</p>
<p><a href="https://gitter.im/Front-End-Checklist/Lobby?utm_source=badge&amp;utm_medium=badge&amp;utm_campaign=pr-badge&amp;utm_content=badge"><img src="https://badges.gitter.im/Front-End-Checklist/Lobby.svg" alt="Join the chat at https://gitter.im/Front-End-Checklist/Lobby" /></a> <a href="https://github.com/thedaviddias/Front-End-Checklist/"><img src="https://img.shields.io/badge/Front‑End_Checklist-followed-brightgreen.svg" alt="Front‑End_Checklist followed" /></a> <a href="#backers"><img src="https://opencollective.com/front-end-checklist/backers/badge.svg" alt="Backers on Open Collective" /></a> <a href="#sponsors"><img src="https://opencollective.com/front-end-checklist/sponsors/badge.svg" alt="Sponsors on Open Collective" /></a> <a href="https://github.com/thedaviddias/Front-End-Checklist/graphs/contributors"><img src="https://img.shields.io/github/contributors/thedaviddias/Front-End-Checklist.svg" alt="Contributors" /></a> <a href="https://stackshare.io/thedaviddias/front-end-checklist"><img src="https://img.shields.io/badge/tech-stack-0690fa.svg?style=flat" alt="StackShare" /></a> <a href="https://creativecommons.org/publicdomain/zero/1.0/"><img src="https://img.shields.io/badge/license-CC0-green.svg" alt="CC0" /></a></p>
<p>It is based on Front-End developers’ years of experience, with the additions coming from some other open-source checklists.</p>
<h2 id="table-of-contents">Table of Contents</h2>
<ol type="1">
<li><strong><a href="#head">Head</a></strong></li>
<li><strong><a href="#html">HTML</a></strong></li>
<li><strong><a href="#webfonts">Webfonts</a></strong></li>
<li><strong><a href="#css">CSS</a></strong></li>
<li><strong><a href="#images">Images</a></strong></li>
<li><strong><a href="#javascript">JavaScript</a></strong></li>
<li><strong><a href="#security">Security</a></strong></li>
<li><strong><a href="#performance-1">Performance</a></strong></li>
<li><strong><a href="#accessibility">Accessibility</a></strong></li>
<li><strong><a href="#seo">SEO</a></strong></li>
<li><strong><a href="#translations">Translations</a></strong></li>
</ol>
<hr />
<h2 id="how-to-use">How to use?</h2>
<p>All items in the <strong>Front-End Checklist</strong> are required for the majority of the projects, but some elements can be omitted or are not essential (in the case of an administration web app, you may not need RSS feed for example). We choose to use 3 levels of flexibility:</p>
<ul>
<li>[Low][low_img] means that the item is <strong>recommended</strong> but can be omitted in some particular situations.</li>
<li>[Medium][medium_img] means that the item is <strong>highly recommended</strong> and can eventually be omitted in some really particular cases. Some elements, if omitted, can have bad repercussions in terms of performance or SEO.</li>
<li>[High][high_img] means that the item <strong>can’t be omitted</strong> by any reason. You may cause a dysfunction in your page or have accessibility or SEO issues. The testing priority needs to be on these elements first.</li>
</ul>
<p>Some resources possess an emoticon to help you understand which type of content / help you may find on the checklist:</p>
<ul>
<li>📖: documentation or article</li>
<li>🛠: online tool / testing tool</li>
<li>📹: media or video content</li>
</ul>
<blockquote>
<p>You can contribute to the <strong><em>Front-End Checklist App</em></strong> reading the <a href="https://github.com/thedaviddias/Front-End-Checklist/blob/master/README_APP.md">README_APP file</a> which explain everything about the project.</p>
</blockquote>
<hr />
<h2 id="head">Head</h2>
<blockquote>
<p><strong>Notes:</strong> You can find <a href="https://github.com/joshbuchea/HEAD">a list of everything</a> that could be found in the <code>&lt;head&gt;</code> of an HTML document.</p>
</blockquote>
<h3 id="meta-tag">Meta tag</h3>
<ul>
<li>[ ] <strong>Doctype:</strong> [High][high_img] The Doctype is HTML5 and is at the top of all your HTML pages.</li>
</ul>
<div class="sourceCode" id="cb1"><pre class="sourceCode html"><code class="sourceCode html"><a class="sourceLine" id="cb1-1" title="1"><span class="dt">&lt;!doctype </span>html<span class="dt">&gt;</span> <span class="co">&lt;!-- HTML5 --&gt;</span></a></code></pre></div>
<blockquote>
<ul>
<li>📖 <a href="https://www.w3.org/TR/html5/syntax.html#determining-the-character-encoding">Determining the character encoding - HTML5 W3C</a></li>
</ul>
</blockquote>
<p><em>The next 3 meta tags (Charset, X-UA Compatible and Viewport) need to come first in the head.</em></p>
<ul>
<li>[ ] <strong>Charset:</strong> [High][high_img] The charset (UTF-8) is declared correctly.</li>
</ul>
<div class="sourceCode" id="cb2"><pre class="sourceCode html"><code class="sourceCode html"><a class="sourceLine" id="cb2-1" title="1"><span class="co">&lt;!-- Set character encoding for the document --&gt;</span></a>
<a class="sourceLine" id="cb2-2" title="2"><span class="kw">&lt;meta</span><span class="ot"> charset=</span><span class="st">&quot;utf-8&quot;</span><span class="kw">&gt;</span></a></code></pre></div>
<ul>
<li>[ ] <strong>X-UA-Compatible:</strong> [Medium][medium_img] The X-UA-Compatible meta tag is present.</li>
</ul>
<div class="sourceCode" id="cb3"><pre class="sourceCode html"><code class="sourceCode html"><a class="sourceLine" id="cb3-1" title="1"><span class="co">&lt;!-- Instruct Internet Explorer to use its latest rendering engine --&gt;</span></a>
<a class="sourceLine" id="cb3-2" title="2"><span class="kw">&lt;meta</span><span class="ot"> http-equiv=</span><span class="st">&quot;x-ua-compatible&quot;</span><span class="ot"> content=</span><span class="st">&quot;ie=edge&quot;</span><span class="kw">&gt;</span></a></code></pre></div>
<blockquote>
<ul>
<li>📖 <a href="https://msdn.microsoft.com/en-us/library/jj676915(v=vs.85).aspx">Specifying legacy document modes (Internet Explorer)</a></li>
</ul>
</blockquote>
<ul>
<li>[ ] <strong>Viewport:</strong> [High][high_img] The viewport is declared correctly.</li>
</ul>
<div class="sourceCode" id="cb4"><pre class="sourceCode html"><code class="sourceCode html"><a class="sourceLine" id="cb4-1" title="1"><span class="co">&lt;!-- Viewport for responsive web design --&gt;</span></a>
<a class="sourceLine" id="cb4-2" title="2"><span class="kw">&lt;meta</span><span class="ot"> name=</span><span class="st">&quot;viewport&quot;</span><span class="ot"> content=</span><span class="st">&quot;width=device-width, initial-scale=1, viewport-fit=cover&quot;</span><span class="kw">&gt;</span></a></code></pre></div>
<ul>
<li>[ ] <strong>Title:</strong> [High][high_img] A title is used on all pages (SEO: Google calculates the pixel width of the characters used in the title, and it cuts off between 472 and 482 pixels. The average character limit would be around 55-characters).</li>
</ul>
<div class="sourceCode" id="cb5"><pre class="sourceCode html"><code class="sourceCode html"><a class="sourceLine" id="cb5-1" title="1"><span class="co">&lt;!-- Document Title --&gt;</span></a>
<a class="sourceLine" id="cb5-2" title="2"><span class="kw">&lt;title&gt;</span>Page Title less than 55 characters<span class="kw">&lt;/title&gt;</span></a></code></pre></div>
<blockquote>
<ul>
<li>📖 <a href="https://developer.mozilla.org/en-US/docs/Web/HTML/Element/title">Title - HTML - MDN</a></li>
<li>🛠 <a href="https://www.sistrix.com/serp-snippet-generator/">SERP Snippet Generator</a></li>
</ul>
</blockquote>
<ul>
<li>[ ] <strong>Description:</strong> [High][high_img] A meta description is provided, it is unique and doesn’t possess more than 150 characters.</li>
</ul>
<div class="sourceCode" id="cb6"><pre class="sourceCode html"><code class="sourceCode html"><a class="sourceLine" id="cb6-1" title="1"><span class="co">&lt;!-- Meta Description --&gt;</span></a>
<a class="sourceLine" id="cb6-2" title="2"><span class="kw">&lt;meta</span><span class="ot"> name=</span><span class="st">&quot;description&quot;</span><span class="ot"> content=</span><span class="st">&quot;Description of the page less than 150 characters&quot;</span><span class="kw">&gt;</span></a></code></pre></div>
<blockquote>
<ul>
<li>📖 <a href="https://developer.mozilla.org/en-US/docs/Learn/HTML/Introduction_to_HTML/The_head_metadata_in_HTML#Adding_an_author_and_description">Meta Description - HTML - MDN</a></li>
</ul>
</blockquote>
<ul>
<li>[ ] <strong>Favicons:</strong> [Medium][medium_img] Each favicon has been created and displays correctly. If you have only a <code>favicon.ico</code>, put it at the root of your site. Normally you won’t need to use any markup. However, it’s still good practice to link to it using the example below. Today, <strong>PNG format is recommended</strong> over <code>.ico</code> format (dimensions: 32x32px).</li>
</ul>
<div class="sourceCode" id="cb7"><pre class="sourceCode html"><code class="sourceCode html"><a class="sourceLine" id="cb7-1" title="1"><span class="co">&lt;!-- Standard favicon --&gt;</span></a>
<a class="sourceLine" id="cb7-2" title="2"><span class="kw">&lt;link</span><span class="ot"> rel=</span><span class="st">&quot;icon&quot;</span><span class="ot"> type=</span><span class="st">&quot;image/x-icon&quot;</span><span class="ot"> href=</span><span class="st">&quot;https://example.com/favicon.ico&quot;</span><span class="kw">&gt;</span></a>
<a class="sourceLine" id="cb7-3" title="3"><span class="co">&lt;!-- Recommended favicon format --&gt;</span></a>
<a class="sourceLine" id="cb7-4" title="4"><span class="kw">&lt;link</span><span class="ot"> rel=</span><span class="st">&quot;icon&quot;</span><span class="ot"> type=</span><span class="st">&quot;image/png&quot;</span><span class="ot"> href=</span><span class="st">&quot;https://example.com/favicon.png&quot;</span><span class="kw">&gt;</span></a></code></pre></div>
<blockquote>
<ul>
<li>🛠 <a href="https://www.favicon-generator.org/">Favicon Generator</a></li>
<li>🛠 <a href="https://realfavicongenerator.net/">RealFaviconGenerator</a></li>
<li>📖 <a href="https://github.com/audreyr/favicon-cheat-sheet">Favicon Cheat Sheet</a></li>
<li>📖 <a href="https://css-tricks.com/favicon-quiz/">Favicons, Touch Icons, Tile Icons, etc. Which Do You Need? - CSS Tricks</a></li>
<li>📖 <a href="https://caniuse.com/#feat=link-icon-png">PNG favicons - caniuse</a></li>
</ul>
</blockquote>
<ul>
<li>[ ] <strong>Apple Web App Meta:</strong> [Low][low_img] Apple meta-tags are present.</li>
</ul>
<div class="sourceCode" id="cb8"><pre class="sourceCode html"><code class="sourceCode html"><a class="sourceLine" id="cb8-1" title="1"><span class="co">&lt;!-- Apple Touch Icon (at least 200x200px) --&gt;</span></a>
<a class="sourceLine" id="cb8-2" title="2"><span class="kw">&lt;link</span><span class="ot"> rel=</span><span class="st">&quot;apple-touch-icon&quot;</span><span class="ot"> href=</span><span class="st">&quot;/custom-icon.png&quot;</span><span class="kw">&gt;</span></a>
<a class="sourceLine" id="cb8-3" title="3"></a>
<a class="sourceLine" id="cb8-4" title="4"><span class="co">&lt;!-- To run web application in full-screen --&gt;</span></a>
<a class="sourceLine" id="cb8-5" title="5"><span class="kw">&lt;meta</span><span class="ot"> name=</span><span class="st">&quot;apple-mobile-web-app-capable&quot;</span><span class="ot"> content=</span><span class="st">&quot;yes&quot;</span><span class="kw">&gt;</span></a>
<a class="sourceLine" id="cb8-6" title="6"></a>
<a class="sourceLine" id="cb8-7" title="7"><span class="co">&lt;!-- Status Bar Style (see Supported Meta Tags below for available values) --&gt;</span></a>
<a class="sourceLine" id="cb8-8" title="8"><span class="co">&lt;!-- Has no effect unless you have the previous meta tag --&gt;</span></a>
<a class="sourceLine" id="cb8-9" title="9"><span class="kw">&lt;meta</span><span class="ot"> name=</span><span class="st">&quot;apple-mobile-web-app-status-bar-style&quot;</span><span class="ot"> content=</span><span class="st">&quot;black&quot;</span><span class="kw">&gt;</span></a></code></pre></div>
<blockquote>
<ul>
<li>📖 <a href="https://developer.apple.com/library/content/documentation/AppleApplications/Reference/SafariWebContent/ConfiguringWebApplications/ConfiguringWebApplications.html">Configuring Web Applications</a></li>
<li>📖 <a href="https://developer.apple.com/library/content/documentation/AppleApplications/Reference/SafariHTMLRef/Articles/MetaTags.html">Supported Meta Tags</a></li>
</ul>
</blockquote>
<ul>
<li>[ ] <strong>Windows Tiles:</strong> [Low][low_img] Windows tiles are present and linked.</li>
</ul>
<div class="sourceCode" id="cb9"><pre class="sourceCode html"><code class="sourceCode html"><a class="sourceLine" id="cb9-1" title="1"><span class="co">&lt;!-- Microsoft Tiles --&gt;</span></a>
<a class="sourceLine" id="cb9-2" title="2"><span class="kw">&lt;meta</span><span class="ot"> name=</span><span class="st">&quot;msapplication-config&quot;</span><span class="ot"> content=</span><span class="st">&quot;browserconfig.xml&quot;</span> <span class="kw">/&gt;</span></a></code></pre></div>
<p>Minimum required xml markup for the <code>browserconfig.xml</code> file is as follows:</p>
<div class="sourceCode" id="cb10"><pre class="sourceCode xml"><code class="sourceCode xml"><a class="sourceLine" id="cb10-1" title="1"><span class="kw">&lt;?xml</span> version=&quot;1.0&quot; encoding=&quot;utf-8&quot;<span class="kw">?&gt;</span></a>
<a class="sourceLine" id="cb10-2" title="2"><span class="kw">&lt;browserconfig&gt;</span></a>
<a class="sourceLine" id="cb10-3" title="3">   <span class="kw">&lt;msapplication&gt;</span></a>
<a class="sourceLine" id="cb10-4" title="4">     <span class="kw">&lt;tile&gt;</span></a>
<a class="sourceLine" id="cb10-5" title="5">        <span class="kw">&lt;square70x70logo</span><span class="ot"> src=</span><span class="st">&quot;small.png&quot;</span><span class="kw">/&gt;</span></a>
<a class="sourceLine" id="cb10-6" title="6">        <span class="kw">&lt;square150x150logo</span><span class="ot"> src=</span><span class="st">&quot;medium.png&quot;</span><span class="kw">/&gt;</span></a>
<a class="sourceLine" id="cb10-7" title="7">        <span class="kw">&lt;wide310x150logo</span><span class="ot"> src=</span><span class="st">&quot;wide.png&quot;</span><span class="kw">/&gt;</span></a>
<a class="sourceLine" id="cb10-8" title="8">        <span class="kw">&lt;square310x310logo</span><span class="ot"> src=</span><span class="st">&quot;large.png&quot;</span><span class="kw">/&gt;</span></a>
<a class="sourceLine" id="cb10-9" title="9">     <span class="kw">&lt;/tile&gt;</span></a>
<a class="sourceLine" id="cb10-10" title="10">   <span class="kw">&lt;/msapplication&gt;</span></a>
<a class="sourceLine" id="cb10-11" title="11"><span class="kw">&lt;/browserconfig&gt;</span></a></code></pre></div>
<blockquote>
<ul>
<li>📖 <a href="https://msdn.microsoft.com/en-us/library/dn320426(v=vs.85).aspx">Browser configuration schema reference</a></li>
</ul>
</blockquote>
<ul>
<li>[ ] <strong>Canonical:</strong> [Medium][medium_img] Use <code>rel="canonical"</code> to avoid duplicate content.</li>
</ul>
<div class="sourceCode" id="cb11"><pre class="sourceCode html"><code class="sourceCode html"><a class="sourceLine" id="cb11-1" title="1"><span class="co">&lt;!-- Helps prevent duplicate content issues --&gt;</span></a>
<a class="sourceLine" id="cb11-2" title="2"><span class="kw">&lt;link</span><span class="ot"> rel=</span><span class="st">&quot;canonical&quot;</span><span class="ot"> href=</span><span class="st">&quot;http://example.com/2017/09/a-new-article-to-read.html&quot;</span><span class="kw">&gt;</span></a></code></pre></div>
<blockquote>
<ul>
<li>📖 <a href="https://support.google.com/webmasters/answer/139066?hl=en">Use canonical URLs - Search Console Help - Google Support</a></li>
<li>📖 <a href="https://webmasters.googleblog.com/2013/04/5-common-mistakes-with-relcanonical.html">5 common mistakes with rel=canonical - Google Webmaster Blog</a></li>
</ul>
</blockquote>
<h3 id="html-tags">HTML tags</h3>
<ul>
<li>[ ] <strong>Language attribute:</strong> [High][high_img] The <code>lang</code> attribute of your website is specified and related to the language of the current page.</li>
</ul>
<div class="sourceCode" id="cb12"><pre class="sourceCode html"><code class="sourceCode html"><a class="sourceLine" id="cb12-1" title="1"><span class="kw">&lt;html</span><span class="ot"> lang=</span><span class="st">&quot;en&quot;</span><span class="kw">&gt;</span></a></code></pre></div>
<ul>
<li>[ ] <strong>Direction attribute:</strong> [Medium][medium_img] The direction of lecture is specified on the html tag (It can be used on another HTML tag).</li>
</ul>
<div class="sourceCode" id="cb13"><pre class="sourceCode html"><code class="sourceCode html"><a class="sourceLine" id="cb13-1" title="1"><span class="kw">&lt;html</span><span class="ot"> dir=</span><span class="st">&quot;rtl&quot;</span><span class="kw">&gt;</span></a></code></pre></div>
<blockquote>
<ul>
<li>📖 <a href="https://developer.mozilla.org/en-US/docs/Web/HTML/Global_attributes/dir">dir - HTML - MDN</a></li>
</ul>
</blockquote>
<ul>
<li>[ ] <strong>Alternate language:</strong> [Low][low_img] The language tag of your website is specified and related to the language of the current page.</li>
</ul>
<div class="sourceCode" id="cb14"><pre class="sourceCode html"><code class="sourceCode html"><a class="sourceLine" id="cb14-1" title="1"><span class="kw">&lt;link</span><span class="ot"> rel=</span><span class="st">&quot;alternate&quot;</span><span class="ot"> href=</span><span class="st">&quot;https://es.example.com/&quot;</span><span class="ot"> hreflang=</span><span class="st">&quot;es&quot;</span><span class="kw">&gt;</span></a></code></pre></div>
<ul>
<li>[ ] <strong>Conditional comments:</strong> [Low][low_img] Conditional comments are present for IE if needed.</li>
</ul>
<blockquote>
<ul>
<li>📖 <a href="https://msdn.microsoft.com/en-us/library/ms537512(v=vs.85).aspx">About conditional comments (Internet Explorer) - MSDN - Microsoft</a></li>
</ul>
</blockquote>
<ul>
<li><p>[ ] <strong>RSS feed:</strong> [Low][low_img] If your project is a blog or has articles, an RSS link was provided.</p></li>
<li><p>[ ] <strong>CSS Critical:</strong> [Medium][medium_img] The CSS critical (or “above the fold”) collects all the CSS used to render the visible portion of the page. It is embedded before your principal CSS call and between <code>&lt;style&gt;&lt;/style&gt;</code> in a single line (minified).</p></li>
</ul>
<blockquote>
<ul>
<li>🛠 <a href="https://github.com/addyosmani/critical">Critical by Addy Osmani on GitHub</a> automates this.</li>
</ul>
</blockquote>
<ul>
<li>[ ] <strong>CSS order:</strong> [High][high_img] All CSS files are loaded before any JavaScript files in the <code>&lt;head&gt;</code>. (Except the case where sometimes JS files are loaded asynchronously on top of your page).</li>
</ul>
<h3 id="social-meta">Social meta</h3>
<p><strong><em>Facebook OG</em></strong> and <strong><em>Twitter Cards</em></strong> are, for any website, highly recommended. The other social media tags can be considered if you target a particular presence on those and want to ensure the display.</p>
<ul>
<li>[ ] <strong>Facebook Open Graph:</strong> [Low][low_img] All Facebook Open Graph (OG) are tested and no one is missing or with a false information. Images need to be at least 600 x 315 pixels, although 1200 x 630 pixels is recommended.</li>
</ul>
<blockquote>
<p><strong>Notes:</strong> Using <code>og:image:width</code> and <code>og:image:height</code> will specify the image dimensions to the crawler so that it can render the image immediately without having to asynchronously download and process it.</p>
</blockquote>
<div class="sourceCode" id="cb15"><pre class="sourceCode html"><code class="sourceCode html"><a class="sourceLine" id="cb15-1" title="1"><span class="kw">&lt;meta</span><span class="ot"> property=</span><span class="st">&quot;og:type&quot;</span><span class="ot"> content=</span><span class="st">&quot;website&quot;</span><span class="kw">&gt;</span></a>
<a class="sourceLine" id="cb15-2" title="2"><span class="kw">&lt;meta</span><span class="ot"> property=</span><span class="st">&quot;og:url&quot;</span><span class="ot"> content=</span><span class="st">&quot;https://example.com/page.html&quot;</span><span class="kw">&gt;</span></a>
<a class="sourceLine" id="cb15-3" title="3"><span class="kw">&lt;meta</span><span class="ot"> property=</span><span class="st">&quot;og:title&quot;</span><span class="ot"> content=</span><span class="st">&quot;Content Title&quot;</span><span class="kw">&gt;</span></a>
<a class="sourceLine" id="cb15-4" title="4"><span class="kw">&lt;meta</span><span class="ot"> property=</span><span class="st">&quot;og:image&quot;</span><span class="ot"> content=</span><span class="st">&quot;https://example.com/image.jpg&quot;</span><span class="kw">&gt;</span></a>
<a class="sourceLine" id="cb15-5" title="5"><span class="kw">&lt;meta</span><span class="ot"> property=</span><span class="st">&quot;og:description&quot;</span><span class="ot"> content=</span><span class="st">&quot;Description Here&quot;</span><span class="kw">&gt;</span></a>
<a class="sourceLine" id="cb15-6" title="6"><span class="kw">&lt;meta</span><span class="ot"> property=</span><span class="st">&quot;og:site_name&quot;</span><span class="ot"> content=</span><span class="st">&quot;Site Name&quot;</span><span class="kw">&gt;</span></a>
<a class="sourceLine" id="cb15-7" title="7"><span class="kw">&lt;meta</span><span class="ot"> property=</span><span class="st">&quot;og:locale&quot;</span><span class="ot"> content=</span><span class="st">&quot;en_US&quot;</span><span class="kw">&gt;</span></a>
<a class="sourceLine" id="cb15-8" title="8"><span class="co">&lt;!-- Next tags are optional but recommended --&gt;</span></a>
<a class="sourceLine" id="cb15-9" title="9"><span class="kw">&lt;meta</span><span class="ot"> property=</span><span class="st">&quot;og:image:width&quot;</span><span class="ot"> content=</span><span class="st">&quot;1200&quot;</span><span class="kw">&gt;</span></a>
<a class="sourceLine" id="cb15-10" title="10"><span class="kw">&lt;meta</span><span class="ot"> property=</span><span class="st">&quot;og:image:height&quot;</span><span class="ot"> content=</span><span class="st">&quot;630&quot;</span><span class="kw">&gt;</span></a></code></pre></div>
<blockquote>
<ul>
<li>📖 <a href="https://developers.facebook.com/docs/sharing/webmasters/">A Guide to Sharing for Webmasters</a></li>
<li>📖 <a href="https://developers.facebook.com/docs/sharing/best-practices/">Best Practices - Sharing</a></li>
<li>🛠 Test your page with the <a href="https://developers.facebook.com/tools/debug/">Facebook OG testing</a></li>
</ul>
</blockquote>
<ul>
<li>[ ] <strong>Twitter Card:</strong> [Low][low_img]</li>
</ul>
<div class="sourceCode" id="cb16"><pre class="sourceCode html"><code class="sourceCode html"><a class="sourceLine" id="cb16-1" title="1"><span class="kw">&lt;meta</span><span class="ot"> name=</span><span class="st">&quot;twitter:card&quot;</span><span class="ot"> content=</span><span class="st">&quot;summary&quot;</span><span class="kw">&gt;</span></a>
<a class="sourceLine" id="cb16-2" title="2"><span class="kw">&lt;meta</span><span class="ot"> name=</span><span class="st">&quot;twitter:site&quot;</span><span class="ot"> content=</span><span class="st">&quot;@site_account&quot;</span><span class="kw">&gt;</span></a>
<a class="sourceLine" id="cb16-3" title="3"><span class="kw">&lt;meta</span><span class="ot"> name=</span><span class="st">&quot;twitter:creator&quot;</span><span class="ot"> content=</span><span class="st">&quot;@individual_account&quot;</span><span class="kw">&gt;</span></a>
<a class="sourceLine" id="cb16-4" title="4"><span class="kw">&lt;meta</span><span class="ot"> name=</span><span class="st">&quot;twitter:url&quot;</span><span class="ot"> content=</span><span class="st">&quot;https://example.com/page.html&quot;</span><span class="kw">&gt;</span></a>
<a class="sourceLine" id="cb16-5" title="5"><span class="kw">&lt;meta</span><span class="ot"> name=</span><span class="st">&quot;twitter:title&quot;</span><span class="ot"> content=</span><span class="st">&quot;Content Title&quot;</span><span class="kw">&gt;</span></a>
<a class="sourceLine" id="cb16-6" title="6"><span class="kw">&lt;meta</span><span class="ot"> name=</span><span class="st">&quot;twitter:description&quot;</span><span class="ot"> content=</span><span class="st">&quot;Content description less than 200 characters&quot;</span><span class="kw">&gt;</span></a>
<a class="sourceLine" id="cb16-7" title="7"><span class="kw">&lt;meta</span><span class="ot"> name=</span><span class="st">&quot;twitter:image&quot;</span><span class="ot"> content=</span><span class="st">&quot;https://example.com/image.jpg&quot;</span><span class="kw">&gt;</span></a></code></pre></div>
<blockquote>
<ul>
<li>📖 <a href="https://developer.twitter.com/en/docs/tweets/optimize-with-cards/guides/getting-started">Getting started with cards — Twitter Developers</a></li>
<li>🛠 Test your page with the <a href="https://cards-dev.twitter.com/validator">Twitter card validator</a></li>
</ul>
</blockquote>
<p><strong><a href="#table-of-contents">⬆ back to top</a></strong></p>
<hr />
<h2 id="html">HTML</h2>
<h3 id="best-practices">Best practices</h3>
<ul>
<li>[ ] <strong>HTML5 Semantic Elements:</strong> [High][high_img] HTML5 Semantic Elements are used appropriately (header, section, footer, main…).</li>
</ul>
<blockquote>
<ul>
<li>📖 <a href="http://htmlreference.io/">HTML Reference</a></li>
</ul>
</blockquote>
<ul>
<li><p>[ ] <strong>Error pages:</strong> [High][high_img] Error 404 page and 5xx exist. Remember that the 5xx error pages need to have their CSS integrated (no external call on the current server).</p></li>
<li><p>[ ] <strong>Noopener:</strong> [Medium][medium_img] In case you are using external links with <code>target="_blank"</code>, your link should have a <code>rel="noopener"</code> attribute to prevent tab nabbing. If you need to support older versions of Firefox, use <code>rel="noopener noreferrer"</code>.</p></li>
</ul>
<blockquote>
<ul>
<li>📖 <a href="https://mathiasbynens.github.io/rel-noopener/">About rel=noopener</a></li>
</ul>
</blockquote>
<ul>
<li>[ ] <strong>Clean up comments:</strong> [Low][low_img] Unnecessary code needs to be removed before sending the page to production.</li>
</ul>
<h3 id="html-testing">HTML testing</h3>
<ul>
<li>[ ] <strong>W3C compliant:</strong> [High][high_img] All pages need to be tested with the W3C validator to identify possible issues in the HTML code.</li>
</ul>
<blockquote>
<ul>
<li>🛠 <a href="https://validator.w3.org/">W3C validator</a></li>
</ul>
</blockquote>
<ul>
<li>[ ] <strong>HTML Lint:</strong> [High][high_img] I use tools to help me analyze any issues I could have on my HTML code.</li>
</ul>
<blockquote>
<ul>
<li>🛠 <a href="https://dirtymarkup.com/">Dirty markup</a></li>
</ul>
</blockquote>
<blockquote>
<ul>
<li>🛠 <a href="https://sonarwhal.com/">Sonar a linting tool for the web</a></li>
</ul>
</blockquote>
<ul>
<li>[ ] <strong>Link checker:</strong> [High][high_img] There are no broken links in my page, verify that you don’t have any 404 error.</li>
</ul>
<blockquote>
<ul>
<li>🛠 <a href="https://validator.w3.org/checklink">W3C Link Checker</a></li>
</ul>
</blockquote>
<ul>
<li>[ ] <strong>Adblockers test:</strong> [Medium][medium_img] Your website shows your content correctly with adblockers enabled (You can provide a message encouraging people to disable their adblocker).</li>
</ul>
<p><strong><a href="#table-of-contents">⬆ back to top</a></strong></p>
<hr />
<h2 id="webfonts">Webfonts</h2>
<blockquote>
<p><strong>Notes:</strong> Using webfonts may cause Flash Of Unstyled Text/Flash Of Invisible Text - consider having fallback fonts and/or utilizing webfont loaders to control behavior. * 📖 <a href="https://developers.google.com/fonts/docs/technical_considerations">Google Technical considerations about webfonts</a></p>
</blockquote>
<ul>
<li>[ ] <strong>Webfont format:</strong> [High][high_img] WOFF, WOFF2 and TTF are supported by all modern browsers.</li>
</ul>
<blockquote>
<ul>
<li>📖 <a href="https://caniuse.com/#feat=woff">WOFF - Web Open Font Format - Caniuse</a>.</li>
<li>📖 <a href="https://caniuse.com/#feat=woff2">WOFF 2.0 - Web Open Font Format - Caniuse</a>.</li>
<li>📖 <a href="https://caniuse.com/#feat=ttf">TTF/OTF - TrueType and OpenType font support</a></li>
<li>📖 <span class="citation" data-cites="font-face">[Using @font-face - CSS-Tricks]</span>(https://css-tricks.com/snippets/css/using-font-face/)</li>
</ul>
</blockquote>
<ul>
<li><p>[ ] <strong>Webfont size:</strong> [High][high_img] Webfont sizes don’t exceed 2 MB (all variants included).</p></li>
<li><p>[ ] <strong>Webfont loader:</strong> [Low][low_img] Control loading behavior with a webfont loader</p></li>
</ul>
<blockquote>
<ul>
<li>🛠 <a href="https://github.com/typekit/webfontloader">Typekit Web Font Loader</a></li>
</ul>
</blockquote>
<p><strong><a href="#table-of-contents">⬆ back to top</a></strong></p>
<hr />
<h2 id="css">CSS</h2>
<blockquote>
<p><strong>Notes:</strong> Take a look at <a href="https://cssguidelin.es/">CSS guidelines</a> and <a href="https://sass-guidelin.es/">Sass Guidelines</a> followed by most Front-End developers. If you have a doubt about CSS properties, you can visit <a href="http://cssreference.io/">CSS Reference</a>. There is also a short <a href="http://codeguide.co/">Code Guide</a> for consistency.</p>
</blockquote>
<ul>
<li>[ ] <strong>Responsive Web Design:</strong> [High][high_img] The website is using responsive web design.</li>
<li>[ ] <strong>CSS Print:</strong> [Medium][medium_img] A print stylesheet is provided and is correct on each page.</li>
<li>[ ] <strong>Preprocessors:</strong> [Low][low_img] Your project is using a CSS preprocessor (e.g <a href="http://sass-lang.com/">Sass</a>, <a href="http://lesscss.org/">Less</a>, <a href="http://stylus-lang.com/">Stylus</a>).</li>
<li>[ ] <strong>Unique ID:</strong> [High][high_img] If IDs are used, they are unique to a page.</li>
<li>[ ] <strong>Reset CSS:</strong> [High][high_img] A CSS reset (reset, normalize or reboot) is used and up to date. <em>(If you are using a CSS Framework like Bootstrap or Foundation, a Normalize is already included into it.)</em></li>
</ul>
<blockquote>
<ul>
<li>📖 <a href="https://meyerweb.com/eric/tools/css/reset/">Reset.css</a></li>
<li>📖 <a href="https://necolas.github.io/normalize.css/">Normalize.css</a></li>
<li>📖 <a href="https://getbootstrap.com/docs/4.0/content/reboot/">Reboot</a></li>
</ul>
</blockquote>
<ul>
<li>[ ] <strong>JS prefix:</strong> [Low][low_img] All classes (or id- used in JavaScript files) begin with <strong>js-</strong> and are not styled into the CSS files.</li>
</ul>
<div class="sourceCode" id="cb17"><pre class="sourceCode html"><code class="sourceCode html"><a class="sourceLine" id="cb17-1" title="1"><span class="kw">&lt;div</span><span class="ot"> id=</span><span class="st">&quot;js-slider&quot;</span><span class="ot"> class=</span><span class="st">&quot;my-slider&quot;</span><span class="kw">&gt;</span></a>
<a class="sourceLine" id="cb17-2" title="2"><span class="co">&lt;!-- Or --&gt;</span></a>
<a class="sourceLine" id="cb17-3" title="3"><span class="kw">&lt;div</span><span class="ot"> id=</span><span class="st">&quot;id-used-by-cms&quot;</span><span class="ot"> class=</span><span class="st">&quot;js-slider my-slider&quot;</span><span class="kw">&gt;</span></a></code></pre></div>
<ul>
<li>[ ] <strong>embedded or inline CSS:</strong> [High][high_img] Avoid at all cost embedding CSS in <code>&lt;style&gt;</code> tags or using inline CSS: only use for valid reasons (e.g. background-image for slider, critical CSS).</li>
<li>[ ] <strong>Vendor prefixes:</strong> [High][high_img] CSS vendor prefixes are used and are generated accordingly with your browser support compatibility.</li>
</ul>
<blockquote>
<ul>
<li>🛠 <a href="https://autoprefixer.github.io/">Autoprefixer CSS online</a></li>
</ul>
</blockquote>
<h3 id="performance">Performance</h3>
<ul>
<li>[ ] <strong>Concatenation:</strong> [High][high_img] CSS files are concatenated in a single file <em>(Not for HTTP/2)</em>.</li>
<li>[ ] <strong>Minification:</strong> [High][high_img] All CSS files are minified.</li>
<li>[ ] <strong>Non-blocking:</strong> [Medium][medium_img] CSS files need to be non-blocking to prevent the DOM from taking time to load.</li>
</ul>
<blockquote>
<ul>
<li>📖 <a href="https://github.com/filamentgroup/loadCSS">loadCSS by filament group</a></li>
<li>📖 <a href="https://gist.github.com/thedaviddias/c24763b82b9991e53928e66a0bafc9bf">Example of preload CSS using loadCSS</a></li>
</ul>
</blockquote>
<ul>
<li>[ ] <strong>Unused CSS:</strong> [Low][low_img] Remove unused CSS.</li>
</ul>
<blockquote>
<ul>
<li>🛠 <a href="https://uncss-online.com/">UnCSS Online</a></li>
<li>🛠 <a href="https://github.com/purifycss/purifycss">PurifyCSS</a></li>
<li>🛠 <a href="https://developers.google.com/web/updates/2017/04/devtools-release-notes#coverage">Chrome DevTools Coverage</a></li>
</ul>
</blockquote>
<h3 id="css-testing">CSS testing</h3>
<ul>
<li>[ ] <strong>Stylelint:</strong> [High][high_img] All CSS or SCSS files are without any errors.</li>
</ul>
<blockquote>
<ul>
<li>🛠 <a href="https://stylelint.io/">stylelint, a CSS linter</a></li>
<li>📖 <a href="https://sass-guidelin.es/">Sass guidelines</a></li>
</ul>
</blockquote>
<ul>
<li><p>[ ] <strong>Responsive web design:</strong> [High][high_img] All pages were tested at the following breakpoints: 320px, 768px, 1024px (can be more / different according to your analytics).</p></li>
<li><p>[ ] <strong>CSS Validator:</strong> [Medium][medium_img] The CSS was tested and pertinent errors were corrected.</p></li>
</ul>
<blockquote>
<ul>
<li>🛠 <a href="https://jigsaw.w3.org/css-validator/">CSS Validator</a></li>
</ul>
</blockquote>
<ul>
<li>[ ] <strong>Desktop Browsers:</strong> [High][high_img] All pages were tested on all current desktop browsers (Safari, Firefox, Chrome, Internet Explorer, EDGE…).</li>
<li>[ ] <strong>Mobile Browsers:</strong> [High][high_img] All pages were tested on all current mobile browsers (Native browser, Chrome, Safari…).</li>
<li><p>[ ] <strong>OS:</strong> [High][high_img] All pages were tested on all current OS (Windows, Android, iOS, Mac…).</p></li>
<li><p>[ ] <strong>Design fidelity:</strong> [Low][low_img] Depending the project and the quality of the creatives, you may be asked to be close to the design. You can use some tools to compare creatives with your code implementation and ensure consistency.</p></li>
</ul>
<blockquote>
<p><a href="https://chrome.google.com/webstore/detail/perfectpixel-by-welldonec/dkaagdgjmgdmbnecmcefdhjekcoceebi?hl=en">Pixel Perfect - Chrome Extension</a></p>
</blockquote>
<ul>
<li>[ ] <strong>Reading direction:</strong> [High][high_img] All pages need to be tested for LTR and RTL languages if they need to be supported.</li>
</ul>
<blockquote>
<ul>
<li>📖 <a href="https://hacks.mozilla.org/2015/09/building-rtl-aware-web-apps-and-websites-part-1/">Building RTL-Aware Web Apps &amp; Websites: Part 1 - Mozilla Hacks</a></li>
<li>📖 <a href="https://hacks.mozilla.org/2015/10/building-rtl-aware-web-apps-websites-part-2/">Building RTL-Aware Web Apps &amp; Websites: Part 2 - Mozilla Hacks</a></li>
</ul>
</blockquote>
<p><strong><a href="#table-of-contents">⬆ back to top</a></strong></p>
<hr />
<h2 id="images">Images</h2>
<blockquote>
<p><strong>Notes:</strong> For a complete understanding of image optimization, check the free ebook <strong><a href="https://images.guide/">Essential Image Optimization</a></strong> from Addy Osmani.</p>
</blockquote>
<h3 id="best-practices-1">Best practices</h3>
<ul>
<li>[ ] <strong>Optimization:</strong> [High][high_img] All images are optimized to be rendered in the browser. WebP format could be used for critical pages (like Homepage).</li>
</ul>
<blockquote>
<ul>
<li>🛠 <a href="https://github.com/imagemin/imagemin">Imagemin</a></li>
<li>🛠 Use <a href="https://imageoptim.com/">ImageOptim</a> to optimise your images for free.</li>
<li>🛠 Use <a href="https://kraken.io/web-interface">Kraken.io</a> awesome alternative for both png and jpg optimization. Up to 1mb per files on free plan.</li>
<li>🛠 <a href="https://tinypng.com/">TinyPNG</a> losslessly optimise png, apng (animated png) and jpg images. Free and paid version available.</li>
<li>🛠 <a href="http://quasimondo.com/ZorroSVG/">ZorroSVG</a> jpg-like compression for transparent images using svg masking.</li>
<li>🛠 <a href="https://github.com/svg/svgo">SVGO</a> a Nodejs-based tool for optimizing SVG vector graphics files.</li>
<li>🛠 <a href="https://jakearchibald.github.io/svgomg/">SVGOMG</a> a web-based GUI version of SVGO for optimising your svgs online.</li>
</ul>
</blockquote>
<ul>
<li>[ ] <strong>Picture/Srcset:</strong> [Medium][medium_img] You use picture/srcset to provide the most appropriate image for the current viewport of the user.</li>
</ul>
<blockquote>
<ul>
<li>📖 <a href="https://www.sitepoint.com/how-to-build-responsive-images-with-srcset/">How to Build Responsive Images with srcset</a></li>
</ul>
</blockquote>
<ul>
<li>[ ] <strong>Retina:</strong> [Low][low_img] You provide layout images 2x or 3x, support retina display.</li>
<li>[ ] <strong>Sprite:</strong> [Medium][medium_img] Small images are in a sprite file (in the case of icons, they can be in an SVG sprite image).</li>
<li>[ ] <strong>Width and Height:</strong> [High][high_img] Set <code>width</code> and <code>height</code> attributes on <code>&lt;img&gt;</code> if the final rendered image size is known (can be omitted for CSS sizing).</li>
<li>[ ] <strong>Alternative text:</strong> [High][high_img] All <code>&lt;img&gt;</code> have an alternative text which describe the image visually.</li>
</ul>
<blockquote>
<ul>
<li>📖 <a href="https://axesslab.com/alt-texts/">Alt-texts: The Ultimate Guide</a></li>
</ul>
</blockquote>
<ul>
<li>[ ] <strong>Lazy loading:</strong> [Medium][medium_img] Images are lazyloaded (A noscript fallback is always provided).</li>
</ul>
<p><strong><a href="#table-of-contents">⬆ back to top</a></strong></p>
<hr />
<h2 id="javascript">JavaScript</h2>
<h3 id="best-practices-2">Best practices</h3>
<ul>
<li>[ ] <strong>JavaScript Inline:</strong> [High][high_img] You don’t have any JavaScript code inline (mixed with your HTML code).</li>
<li>[ ] <strong>Concatenation:</strong> [High][high_img] JavaScript files are concatenated.</li>
<li>[ ] <strong>Minification:</strong> [High][high_img] JavaScript files are minified (you can add the <code>.min</code> suffix).</li>
</ul>
<blockquote>
<ul>
<li>📖 <a href="https://developers.google.com/speed/docs/insights/MinifyResources">Minify Resources (HTML, CSS, and JavaScript)</a></li>
</ul>
</blockquote>
<ul>
<li>[ ] <strong>JavaScript security:</strong> [High][high_img]</li>
</ul>
<blockquote>
<ul>
<li>📖 <a href="https://www.owasp.org/index.php/DOM_based_XSS_Prevention_Cheat_Sheet#Guidelines_for_Developing_Secure_Applications_Utilizing_JavaScript">Guidelines for Developing Secure Applications Utilizing JavaScript</a></li>
</ul>
</blockquote>
<ul>
<li>[ ] <strong><code>noscript</code> tag:</strong> [Medium][medium_img] Use <code>&lt;noscript&gt;</code> tag in the HTML body if a script type on the page is unsupported or if scripting is currently turned off in the browser. This will be helpful in client-side rendering heavy apps such as React.js, see <a href="https://webdesign.tutsplus.com/tutorials/quick-tip-dont-forget-the-noscript-element--cms-25498">examples</a>.</li>
</ul>
<div class="sourceCode" id="cb18"><pre class="sourceCode html"><code class="sourceCode html"><a class="sourceLine" id="cb18-1" title="1"><span class="kw">&lt;noscript&gt;</span></a>
<a class="sourceLine" id="cb18-2" title="2">  You need to enable JavaScript to run this app.</a>
<a class="sourceLine" id="cb18-3" title="3"><span class="kw">&lt;/noscript&gt;</span></a></code></pre></div>
<ul>
<li>[ ] <strong>Non-blocking:</strong> [Medium][medium_img] JavaScript files are loaded asynchronously using <code>async</code> or deferred using <code>defer</code> attribute.</li>
</ul>
<blockquote>
<ul>
<li>📖 <a href="https://developers.google.com/speed/docs/insights/BlockingJS">Remove Render-Blocking JavaScript</a></li>
</ul>
</blockquote>
<ul>
<li>[ ] <strong>Optimized and updated JS libraries:</strong> [Medium][medium_img] All JavaScript libraries used in your project are necessary (prefer Vanilla Javascript for simple functionalities), updated to their latest version and don’t overwhelm your JavaScript with unnecessary methods.</li>
</ul>
<blockquote>
<ul>
<li>📖 <a href="http://youmightnotneedjquery.com/">You may not need jQuery</a></li>
<li>📖 <a href="https://plainjs.com/">Vanilla JavaScript for building powerful web applications</a></li>
</ul>
</blockquote>
<ul>
<li>[ ] <strong>Modernizr:</strong> [Low][low_img] If you need to target some specific features you can use a custom Modernizr to add classes in your <code>&lt;html&gt;</code> tag.</li>
</ul>
<blockquote>
<ul>
<li>🛠 <a href="https://modernizr.com/download?setclasses">Customize your Modernizr</a></li>
</ul>
</blockquote>
<h3 id="javascript-testing">JavaScript testing</h3>
<ul>
<li>[ ] <strong>ESLint:</strong> [High][high_img] No errors are flagged by ESLint (based on your configuration or standards rules).</li>
</ul>
<blockquote>
<ul>
<li>📖 <a href="https://eslint.org/">ESLint - The pluggable linting utility for JavaScript and JSX</a></li>
</ul>
</blockquote>
<p><strong><a href="#table-of-contents">⬆ back to top</a></strong></p>
<hr />
<h2 id="security">Security</h2>
<h3 id="scan-and-check-your-web-site">Scan and check your web site</h3>
<blockquote>
<ul>
<li><a href="https://securityheaders.io/">securityheaders.io</a></li>
<li><a href="https://observatory.mozilla.org/">Observatory by Mozilla</a></li>
<li><a href="https://asafaweb.com/">ASafaWeb - Automated Security Analyser for ASP.NET Websites</a></li>
</ul>
</blockquote>
<h3 id="best-practices-3">Best practices</h3>
<ul>
<li>[ ] <strong>HTTPS:</strong> [Medium][medium_img] HTTPS is used on every pages and for all external content (plugins, images…).</li>
</ul>
<blockquote>
<ul>
<li>🛠 <a href="https://letsencrypt.org/">Let’s Encrypt - Free SSL/TLS Certificates</a></li>
<li>🛠 <a href="https://www.ssllabs.com/ssltest/index.html">Free SSL Server Test</a></li>
<li>📖 <a href="http://caniuse.com/#feat=stricttransportsecurity">Strict Transport Security</a></li>
</ul>
</blockquote>
<ul>
<li>[ ] <strong>HTTP Strict Transport Security (HSTS):</strong> [Medium][medium_img] The HTTP header is set to ‘Strict-Transport-Security’.</li>
</ul>
<blockquote>
<ul>
<li>🛠 <a href="https://hstspreload.org/">Check HSTS preload status and eligibility</a></li>
<li>📖 <a href="https://www.owasp.org/index.php/HTTP_Strict_Transport_Security_Cheat_Sheet">HTTP Strict Transport Security Cheat Sheet - OWASP</a></li>
<li>📖 <a href="https://www.owasp.org/index.php/Transport_Layer_Protection_Cheat_Sheet">Transport Layer Protection Cheat Sheet - OWASP</a></li>
</ul>
</blockquote>
<ul>
<li>[ ] <strong>Cross Site Request Forgery (CSRF):</strong> [High][high_img] You ensure that requests made to your server-side are legitimate and originate from your website / app to prevent CSRF attacks.</li>
</ul>
<blockquote>
<ul>
<li>📖 <a href="https://www.owasp.org/index.php/Cross-Site_Request_Forgery_(CSRF)_Prevention_Cheat_Sheet">Cross-Site Request Forgery (CSRF) Prevention Cheat Sheet - OWASP</a></li>
</ul>
</blockquote>
<ul>
<li>[ ] <strong>Cross Site Scripting (XSS):</strong> [High][high_img] Your page or website is free from XSS possible issues.</li>
</ul>
<blockquote>
<ul>
<li>📖 <a href="https://www.owasp.org/index.php/XSS_(Cross_Site_Scripting)_Prevention_Cheat_Sheet">XSS (Cross Site Scripting) Prevention Cheat Sheet - OWASP</a></li>
<li>📖 <a href="https://www.owasp.org/index.php/DOM_based_XSS_Prevention_Cheat_Sheet">DOM based XSS Prevention Cheat Sheet - OWASP</a></li>
</ul>
</blockquote>
<ul>
<li>[ ] <strong>Content Type Options:</strong> [Medium][medium_img] Prevents Google Chrome and Internet Explorer from trying to mime-sniff the content-type of a response away from the one being declared by the server.</li>
</ul>
<blockquote>
<ul>
<li>📖 <a href="https://scotthelme.co.uk/hardening-your-http-response-headers/#x-content-type-options">X-Content-Type-Options - Scott Helme</a></li>
</ul>
</blockquote>
<ul>
<li>[ ] <strong>X-Frame-Options (XFO):</strong> [Medium][medium_img] Protects your visitors against clickjacking attacks.</li>
</ul>
<blockquote>
<ul>
<li>📖 <a href="https://scotthelme.co.uk/hardening-your-http-response-headers/#x-frame-options">X-Frame-Options - Scott Helme</a></li>
<li>📖 <a href="https://tools.ietf.org/html/rfc7034">RFC7034 - HTTP Header Field X-Frame-Options</a></li>
</ul>
</blockquote>
<ul>
<li>[ ] <strong>Content Security Policy:</strong> [Medium][medium_img] Defines how content is loaded on your site and from where it is permitted to be loaded. Can also be used to protect against clickjacking attacks.</li>
</ul>
<blockquote>
<ul>
<li>📖 <a href="https://scotthelme.co.uk/content-security-policy-an-introduction/">Content Security Policy - An Introduction - Scott Helme</a></li>
<li>📖 <a href="https://scotthelme.co.uk/csp-cheat-sheet/">CSP Cheat Sheet - Scott Helme</a></li>
<li>📖 <a href="https://www.owasp.org/index.php/Content_Security_Policy_Cheat_Sheet">CSP Cheat Sheet - OWASP</a></li>
<li>📖 <a href="https://content-security-policy.com/">Content Security Policy Reference</a></li>
</ul>
</blockquote>
<p><strong><a href="#table-of-contents">⬆ back to top</a></strong></p>
<hr />
<h2 id="performance-1">Performance</h2>
<h3 id="best-practices-4">Best practices</h3>
<ul>
<li>[ ] <strong>Page weight:</strong> [High][high_img] The weight of each page is between 0 and 500 KB.</li>
</ul>
<blockquote>
<ul>
<li>🛠 <a href="https://tools.pingdom.com">Website Page Analysis</a></li>
<li>🛠 <a href="https://www.webpagetest.org/">WebPageTest</a></li>
<li>📖 <a href="https://evilmartians.com/chronicles/size-limit-make-the-web-lighter">Size Limit: Make the Web lighter</a></li>
</ul>
</blockquote>
<ul>
<li><p>[ ] <strong>Minified HTML:</strong> [Medium][medium_img] Your HTML is minified.</p></li>
<li><p>[ ] <strong>Lazy loading:</strong> [Medium][medium_img] Images, scripts and CSS need to be lazy loaded to improve the response time of the current page (See details in their respective sections).</p></li>
<li><p>[ ] <strong>Cookie size:</strong> [Medium][medium_img] If you are using cookies be sure each cookie doesn’t exceed 4096 bytes and your domain name doesn’t have more than 20 cookies.</p></li>
</ul>
<blockquote>
<ul>
<li>📖 <a href="https://tools.ietf.org/html/rfc6265">Cookie specification: RFC 6265</a></li>
<li>📖 <a href="https://developer.mozilla.org/en-US/docs/Web/HTTP/Cookies">Cookies</a></li>
<li>🛠 <a href="http://browsercookielimits.squawky.net/">Browser Cookie Limits</a></li>
</ul>
</blockquote>
<ul>
<li>[ ] <strong>Third party components:</strong> [Medium][medium_img] Third party iframes or components relying on external JS (like sharing buttons) are replaced by static components when possible, thus limiting calls to external APIs and keeping your users activity private.</li>
</ul>
<blockquote>
<ul>
<li>🛠 <a href="https://simplesharingbuttons.com/">Simple sharing buttons generator</a></li>
</ul>
</blockquote>
<h3 id="preparing-upcoming-requests">Preparing upcoming requests</h3>
<blockquote>
<ul>
<li>📖 <a href="https://css-tricks.com/prefetching-preloading-prebrowsing/">Explanation of the following techniques</a></li>
</ul>
</blockquote>
<ul>
<li>[ ] <strong>DNS resolution:</strong> [Low][low_img] DNS of third-party services that may be needed are resolved in advance during idle time using <code>dns-prefetch</code>.</li>
</ul>
<div class="sourceCode" id="cb19"><pre class="sourceCode html"><code class="sourceCode html"><a class="sourceLine" id="cb19-1" title="1"><span class="kw">&lt;link</span><span class="ot"> rel=</span><span class="st">&quot;dns-prefetch&quot;</span><span class="ot"> href=</span><span class="st">&quot;https://example.com&quot;</span><span class="kw">&gt;</span></a></code></pre></div>
<ul>
<li>[ ] <strong>Preconnection:</strong> [Low][low_img] DNS lookup, TCP handshake and TLS negotiation with services that will be needed soon is done in advance during idle time using <code>preconnect</code>.</li>
</ul>
<div class="sourceCode" id="cb20"><pre class="sourceCode html"><code class="sourceCode html"><a class="sourceLine" id="cb20-1" title="1"><span class="kw">&lt;link</span><span class="ot"> rel=</span><span class="st">&quot;preconnect&quot;</span><span class="ot"> href=</span><span class="st">&quot;https://example.com&quot;</span><span class="kw">&gt;</span></a></code></pre></div>
<ul>
<li>[ ] <strong>Prefetching:</strong> [Low][low_img] Resources that will be needed soon (e.g. lazy loaded images) are requested in advance during idle time using <code>prefetch</code>.</li>
</ul>
<div class="sourceCode" id="cb21"><pre class="sourceCode html"><code class="sourceCode html"><a class="sourceLine" id="cb21-1" title="1"><span class="kw">&lt;link</span><span class="ot"> rel=</span><span class="st">&quot;prefetch&quot;</span><span class="ot"> href=</span><span class="st">&quot;image.png&quot;</span><span class="kw">&gt;</span></a></code></pre></div>
<ul>
<li>[ ] <strong>Preloading:</strong> [Low][low_img] Resources needed in the current page (e.g. scripts placed at the end of <code>&lt;body&gt;</code>) in advance using <code>preload</code>.</li>
</ul>
<div class="sourceCode" id="cb22"><pre class="sourceCode html"><code class="sourceCode html"><a class="sourceLine" id="cb22-1" title="1"><span class="kw">&lt;link</span><span class="ot"> rel=</span><span class="st">&quot;preload&quot;</span><span class="ot"> href=</span><span class="st">&quot;app.js&quot;</span><span class="kw">&gt;</span></a></code></pre></div>
<blockquote>
<ul>
<li>📖 <a href="https://medium.com/reloading/preload-prefetch-and-priorities-in-chrome-776165961bbf">Difference between prefetch and preload</a></li>
</ul>
</blockquote>
<h3 id="performance-testing">Performance testing</h3>
<ul>
<li>[ ] <strong>Google PageSpeed:</strong> [High][high_img] All your pages were tested (not only the homepage) and have a score of at least 90/100.</li>
</ul>
<blockquote>
<ul>
<li>🛠 <a href="https://developers.google.com/speed/pagespeed/insights/">Google PageSpeed</a></li>
<li>🛠 <a href="https://testmysite.withgoogle.com">Test your mobile speed with Google</a></li>
<li>🛠 <a href="https://www.webpagetest.org/">WebPagetest - Website Performance and Optimization Test</a></li>
<li>🛠 <a href="https://gtmetrix.com/">GTmetrix - Website speed and performance optimization</a></li>
</ul>
</blockquote>
<p><strong><a href="#table-of-contents">⬆ back to top</a></strong></p>
<hr />
<h2 id="accessibility">Accessibility</h2>
<blockquote>
<p><strong>Notes:</strong> You can watch the playlist <a href="https://www.youtube.com/playlist?list=PLNYkxOF6rcICWx0C9LVWWVqvHlYJyqw7g">A11ycasts with Rob Dodson</a> 📹</p>
</blockquote>
<h3 id="best-practices-5">Best practices</h3>
<ul>
<li>[ ] <strong>Progressive enhancement:</strong> [Medium][medium_img] Major functionality like main navigation and search should work without JavaScript enabled.</li>
</ul>
<blockquote>
<ul>
<li>📖 <a href="https://www.youtube.com/watch?v=kBmvq2cE0D8">Enable / Disable JavaScript in Chrome Developer Tools</a></li>
</ul>
</blockquote>
<ul>
<li>[ ] <strong>Color contrast:</strong> [Medium][medium_img] Color contrast should at least pass WCAG AA (AAA for mobile).</li>
</ul>
<blockquote>
<ul>
<li>🛠 <a href="https://leaverou.github.io/contrast-ratio/">Contrast ratio</a></li>
</ul>
</blockquote>
<h4 id="headings">Headings</h4>
<ul>
<li>[ ] <strong>H1:</strong> [High][high_img] All pages have an H1 which is not the title of the website.</li>
<li>[ ] <strong>Headings:</strong> [High][high_img] Headings should be used properly and in the right order (H1 to H6).</li>
</ul>
<blockquote>
<ul>
<li>📹 <a href="https://www.youtube.com/watch?v=vAAzdi1xuUY&amp;index=9&amp;list=PLNYkxOF6rcICWx0C9LVWWVqvHlYJyqw7g">Why headings and landmarks are so important – A11ycasts #18</a></li>
</ul>
</blockquote>
<h4 id="landmarks">Landmarks</h4>
<ul>
<li>[ ] <strong>Role banner:</strong> [High][high_img] <code>&lt;header&gt;</code> has <code>role="banner"</code>.</li>
<li>[ ] <strong>Role navigation:</strong> [High][high_img] <code>&lt;nav&gt;</code> has <code>role="navigation"</code>.</li>
<li>[ ] <strong>Role main:</strong> [High][high_img] <code>&lt;main&gt;</code> has <code>role="main"</code>.</li>
</ul>
<blockquote>
<ul>
<li>📖 <a href="https://www.w3.org/WAI/GL/wiki/Using_ARIA_landmarks_to_identify_regions_of_a_page">Using ARIA landmarks to identify regions of a page</a></li>
<li>📖 <a href="https://www.w3.org/TR/wai-aria/roles#roles_categorization">ARIA roles categorization</a></li>
</ul>
</blockquote>
<h3 id="semantics">Semantics</h3>
<ul>
<li>[ ] <strong>Specific HTML5 input types are used:</strong> [Medium][medium_img] This is especially important for mobile devices that show customized keypads and widgets for different types.</li>
</ul>
<blockquote>
<ul>
<li>📖 <a href="http://mobileinputtypes.com/">Mobile Input Types</a></li>
</ul>
</blockquote>
<h3 id="form">Form</h3>
<ul>
<li>[ ] <strong>Label:</strong> [High][high_img] A label is associated with each input form element. In case a label can’t be displayed, use <code>aria-label</code> instead.</li>
</ul>
<blockquote>
<ul>
<li>📖 <a href="https://developer.mozilla.org/en-US/docs/Web/Accessibility/ARIA/ARIA_Techniques/Using_the_aria-label_attribute">Using the aria-label attribute - MDN</a></li>
</ul>
</blockquote>
<h3 id="accessibility-testing">Accessibility testing</h3>
<ul>
<li>[ ] <strong>Accessibility standards testing:</strong> [High][high_img] Use the WAVE tool to test if your page respects the accessibility standards.</li>
</ul>
<blockquote>
<ul>
<li>🛠 <a href="http://wave.webaim.org/">Wave testing</a></li>
</ul>
</blockquote>
<ul>
<li>[ ] <strong>Keyboard navigation:</strong> [High][high_img] Test your website using only your keyboard in a previsible order. All interactive elements are reachable and usable.</li>
<li>[ ] <strong>Screen-reader:</strong> [Medium][medium_img] All pages were tested in a screen-reader (VoiceOver, ChromeVox, NVDA or Lynx).</li>
<li>[ ] <strong>Focus style:</strong> [High][high_img] If the focus is disabled, it is replaced by visible state in CSS.</li>
</ul>
<blockquote>
<ul>
<li>📹 <a href="https://www.youtube.com/watch?v=srLRSQg6Jgg&amp;index=5&amp;list=PLNYkxOF6rcICWx0C9LVWWVqvHlYJyqw7g">Managing Focus - A11ycasts #22</a></li>
</ul>
</blockquote>
<p><strong><a href="#table-of-contents">⬆ back to top</a></strong></p>
<hr />
<h2 id="seo">SEO</h2>
<ul>
<li>[ ] <strong>Google Analytics:</strong> [High][high_img] Google Analytics is installed and correctly configured.</li>
</ul>
<blockquote>
<ul>
<li>🛠 <a href="https://analytics.google.com/analytics/web/">Google Analytics</a></li>
<li>🛠 <a href="http://www.gachecker.com/">GA Checker (and others)</a></li>
</ul>
</blockquote>
<ul>
<li>[ ] <strong>Headings logic:</strong> [Medium][medium_img] Heading text helps to understand the content in the current page.</li>
</ul>
<blockquote>
<ul>
<li>🛠 <a href="http://khan.github.io/tota11y/#Try-it">Tota11y, tab Headings</a></li>
</ul>
</blockquote>
<ul>
<li>[ ] <strong>sitemap.xml:</strong> [High][high_img] A sitemap.xml exists and was submitted to Google Search Console (previously Google Webmaster Tools).</li>
</ul>
<blockquote>
<ul>
<li>🛠 <a href="https://websiteseochecker.com/html-sitemap-generator/">Sitemap generator</a></li>
</ul>
</blockquote>
<ul>
<li>[ ] <strong>robots.txt:</strong> [High][high_img] The robots.txt is not blocking webpages.</li>
</ul>
<blockquote>
<ul>
<li>📖 <a href="https://varvy.com/robottxt.html">The robots.txt file</a></li>
<li>🛠 Test your robots.txt with <a href="https://www.google.com/webmasters/tools/robots-testing-tool">Google Robots Testing Tool</a></li>
</ul>
</blockquote>
<ul>
<li>[ ] <strong>Structured Data:</strong> [High][high_img] Pages using structured data are tested and are without errors. Structured data helps crawlers understand the content in the current page.</li>
</ul>
<blockquote>
<ul>
<li>📖 <a href="https://developers.google.com/search/docs/guides/intro-structured-data">Introduction to Structured Data - Search - Google Developers</a></li>
<li>📖 <a href="https://rdfa.info/">RDFa - Linked Data in HTML</a></li>
<li>📖 <a href="https://json-ld.org/">JSON-LD</a></li>
<li>📖 <a href="https://www.w3.org/TR/microdata/">Microdata</a></li>
<li>🛠 Test your page with the <a href="https://developers.google.com/structured-data/testing-tool/">Structured Data Testing Tool</a></li>
<li>🛠 Complete list of vocabularies that can be used as structured data. <a href="http://schema.org/docs/full.html">Schema.org Full Hierarchy</a></li>
</ul>
</blockquote>
<ul>
<li>[ ] <strong>Sitemap HTML:</strong> [Medium][medium_img] An HTML sitemap is provided and is accessible via a link in the footer of your website.</li>
</ul>
<blockquote>
<ul>
<li>📖 <a href="https://support.google.com/webmasters/answer/183668?hl=en">Sitemap guidelines - Google Support</a></li>
</ul>
</blockquote>
<ul>
<li>[ ] <strong>Pagination link tags:</strong> [Medium][medium_img] Provide <code>rel="prev"</code> and <code>rel="next"</code> to indicate paginated content.</li>
</ul>
<blockquote>
<ul>
<li>🛠 <a href="https://technicalseo.com/seo-tools/rel-prev-next/">Pagination (rel=“prev/next”) Testing Tool</a></li>
</ul>
</blockquote>
<blockquote>
<ul>
<li>📖 <a href="https://support.google.com/webmasters/answer/1663744?hl=en">Pagination guidelines - Google Support</a></li>
</ul>
</blockquote>
<div class="sourceCode" id="cb23"><pre class="sourceCode html"><code class="sourceCode html"><a class="sourceLine" id="cb23-1" title="1"><span class="co">&lt;!-- Example: Pagination link tags for page 2 of a paginated list --&gt;</span></a>
<a class="sourceLine" id="cb23-2" title="2"><span class="kw">&lt;link</span><span class="ot"> rel=</span><span class="st">&quot;prev&quot;</span><span class="ot"> href=</span><span class="st">&quot;https://example.com/?page=1&quot;</span><span class="kw">&gt;</span></a>
<a class="sourceLine" id="cb23-3" title="3"><span class="kw">&lt;link</span><span class="ot"> rel=</span><span class="st">&quot;next&quot;</span><span class="ot"> href=</span><span class="st">&quot;https://example.com/?page=3&quot;</span><span class="kw">&gt;</span></a></code></pre></div>
<p><strong><a href="#table-of-contents">⬆ back to top</a></strong></p>
<hr />
<h2 id="translations">Translations</h2>
<p>The Front-End Checklist is also available in other languages. Thanks for all translators and their awesome work!</p>
<ul>
<li>🇯🇵 Japanese: <a href="https://github.com/miya0001/Front-End-Checklist">miya0001/Front-End-Checklist</a></li>
<li>🇪🇸 Spanish: <a href="https://github.com/eoasakura/Front-End-Checklist-ES">eoasakura/Front-End-Checklist-ES</a></li>
<li>🇨🇳 Chinese: <a href="https://github.com/JohnsenZhou/Front-End-Checklist">JohnsenZhou/Front-End-Checklist</a></li>
<li>🇰🇷 Korean: <a href="https://github.com/kesuskim/Front-End-Checklist">kesuskim/Front-End-Checklist</a></li>
<li>🇧🇷 Portuguese: <a href="https://github.com/jcezarms/Front-End-Checklist">jcezarms/Front-End-Checklist</a></li>
<li>🇻🇳 Vietnamese: <a href="https://github.com/euclid1990/Front-End-Checklist">euclid1990/Front-End-Checklist</a></li>
<li>🇹🇼 Traditional Chinese: <a href="https://github.com/EngineLin/Front-End-Checklist">EngineLin/Front-End-Checklist</a></li>
<li>🇫🇷 French: <a href="https://github.com/ynizon/Front-End-Checklist">ynizon/Front-End-Checklist</a></li>
<li>🇷🇺 Russian: <a href="https://github.com/ungear/Front-End-Checklist">ungear/Front-End-Checklist</a></li>
<li>🇹🇷 Turkish: <a href="https://github.com/eraycetinay/Front-End-Checklist">eraycetinay/Front-End-Checklist</a></li>
<li>🇩🇪 German: <a href="https://github.com/xFuture603/Front-End-Checklist">xfuture603/Front-End-Checklist</a></li>
</ul>
<hr />
<h2 id="front-end-checklist-badge">Front-End Checklist Badge</h2>
<p>If you want to show you are following the rules of the Front-End Checklist, put this badge on your README file!</p>
<p>➔ <a href="https://github.com/thedaviddias/Front-End-Checklist/"><img src="https://img.shields.io/badge/Front‑End_Checklist-followed-brightgreen.svg" alt="Front‑End_Checklist followed" /></a></p>
<div class="sourceCode" id="cb24"><pre class="sourceCode md"><code class="sourceCode markdown"><a class="sourceLine" id="cb24-1" title="1"><span class="ot">[![Front‑End_Checklist followed](https://img.shields.io/badge/Front‑End_Checklist-followed-brightgreen.svg)</span>](https://github.com/thedaviddias/Front-End-Checklist/)</a></code></pre></div>
<p><strong><a href="#table-of-contents">⬆ back to top</a></strong></p>
</body>
</html>
